#****************************************************************************
#**
#**  File     :  /lua/sim/Weapon.lua
#**  Author(s):  John Comes
#**
#**  Summary  : The base weapon class for all weapons in the game.
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

oldWeapon = Weapon

Weapon = Class(oldWeapon) {
  	# Overwrite the setenabled function so nothing enables the weapons while they are destroyed, and make sure they stop firing after being disabled
	SetEnabled = function(self,enable)
		local imodule = self:GetBlueprint().Label
		if self.OnDisable and self.unit.ModuleStats[imodule].Enabled == false then
			LOG('Beam Weapon Disabled')
			self:OnDisable()
		elseif self.unit.ModuleStats[imodule].Enabled == false then
			self:ResetTarget()
			#LOG(imodule, ' disabled')
		end
		if self.unit.ModuleStats[imodule] and self.unit.ModuleStats[imodule].Enabled == true then
			oldWeapon.SetEnabled(self,true)
		elseif self.unit.ModuleStats[imodule] and self.unit.ModuleStats[imodule].Enabled == false then
			oldWeapon.SetEnabled(self,false)
		else
			oldWeapon.SetEnabled(self,enable)
		end
	end
}
