local Projectile = import('/lua/sim/projectile.lua').Projectile
local explosion = import('/lua/defaultexplosions.lua')
local EffectTemplate = import('/lua/EffectTemplates.lua')
local EfctUtil = import('/lua/EffectUtilities.lua')
local CreateBoneEffects = EfctUtil.CreateBoneEffects

CustomProjectile = Class(Projectile) {

	OnCreate = function(self)
		self.wreck = 
		Projectile.OnCreate(self)
	end,
	
	OnImpact = function(self, targetType, targetEntity)
		Projectile.OnImpact(self, targetType, targetEntity)
		Explosion =  EffectTemplate.FireCloudMed01
		Debris = EffectTemplate.ExplosionDebrisSml01 
		Smoke = EffectTemplate.SmokeSml01
		
		CreateBoneEffects( self,-1, self:GetArmy(), Smoke)
		CreateLightParticleIntel( self, -1, self:GetArmy(), 3, 9, 'glow_03', 'ramp_blue_13' )
			
		CreateBoneEffects( self,-1, self:GetArmy(), Explosion)
			
		CreateBoneEffects( self,-1, self:GetArmy(), Debris)
		
		self:CreateProjWreckage()
	end,
	
	CreateProjWreckage = function(self)
		local wreck = '/props/DefaultWreckage/DefaultWreckage_prop.bp'
		if wreck then
			--LOG('Creating wreckage')

			local unit = self.parent
			local bp = unit:GetBlueprint()

			local pos = self:GetPosition()
			pos.y = pos.y  - ( bp.DamagableModules[self.label].WreckageOffset or 0)
			local prop = CreateProp( pos, wreck)
			
			prop:AddBoundedProp(0)
			prop:SetScale(bp.Display.UniformScale)
			prop:SetOrientation(self:GetOrientation(), true)
			prop:SetMaxReclaimValues(0, 0, 0, 0)
			--LOG(repr(self:GetCurrentTargetPosition()))

			
			prop:SetReclaimValues(0, 0, 0, 0)
			prop:SetMaxHealth(300)
			prop:SetHealth(self, 300)
        	local bp = self:GetBlueprint().Audio
        	if bp then
            	self:PlaySound(bp['Destroyed'])
            end
			
			local path
	    	if EntityCategoryContains(categories.COMMAND,unit) and EntityCategoryContains(categories.UEF,unit) and unit:HasEnhancement('Resource_Allocation') then
	    		path = '/mods/ModularDamage/moddata/' .. unit:GetUnitId() .. '/' .. self.label  ..'_upgrade_mesh_wreck'
	    	else
	    		path = '/mods/ModularDamage/moddata/' .. unit:GetUnitId() .. '/' .. self.label  ..'_mesh_wreck'
	    	end
			prop:SetMesh(path)
		end
	end,
}
